using Toybox.Graphics as Gfx;
using Toybox.Math as Math;

import Toybox.Lang;

using C as C;

class Hash
{

var max;
var bg_l;

var ticks as Array<Array<Array<Number>>> = new [60];

public function initialize(max, sm_l, sm_w, bg_l, bg_w)
{
    var a;

    me.max = max;
    me.bg_l = bg_l;

    var w2 = sm_w / 2;
    var sm_v = new [4];
    sm_v[0] = [ -w2, -max + sm_l];
    sm_v[1] = [ -w2, -max ];
    sm_v[2] = [ +w2, -max ];
    sm_v[3] = [ +w2, -max + sm_l ];

    w2 = bg_w / 2;
    var bg_v = new [4];
    bg_v[0] = [ -w2, -max + bg_l];
    bg_v[1] = [ -w2, -max ];
    bg_v[2] = [ +w2, -max ];
    bg_v[3] = [ +w2, -max + bg_l ];

    for (var sec = 0; sec < 60; sec += 1) {
        a = (((Math.PI * 2) * sec) / 60) + (Math.PI/2);
        if ((sec % 5) == 0) {
            ticks[sec] = C.translate(bg_v, C.center_x, C.center_y, a);
        } else {
            ticks[sec] = C.translate(sm_v, C.center_x, C.center_y, a); }
    }
}

public function start_x()
{

    return max - bg_l;
}

public function show(dc, val, c)
{

    if (val < 0) {
        val += 60; }
    dc.setColor(c, C.TRANSPARENT);
    dc.fillPolygon(ticks[val]);
}

}
